
;CodeVisionAVR C Compiler V1.25.8 Professional
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega32
;Program type           : Application
;Clock frequency        : 12,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 512 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega32
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2048
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "main.vec"
	.INCLUDE "main.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x800)
	LDI  R25,HIGH(0x800)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x85F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x85F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x260)
	LDI  R29,HIGH(0x260)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x260
;       1 #include <mega32.h>
;       2 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;       3 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;       4 	.EQU __se_bit=0x80
	.EQU __se_bit=0x80
;       5 	.EQU __sm_mask=0x70
	.EQU __sm_mask=0x70
;       6 	.EQU __sm_powerdown=0x20
	.EQU __sm_powerdown=0x20
;       7 	.EQU __sm_powersave=0x30
	.EQU __sm_powersave=0x30
;       8 	.EQU __sm_standby=0x60
	.EQU __sm_standby=0x60
;       9 	.EQU __sm_ext_standby=0x70
	.EQU __sm_ext_standby=0x70
;      10 	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_adc_noise_red=0x10
;      11 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      12 	#endif
	#endif
;      13 
;      14 #include <stdio.h>
;      15 #include <delay.h>
;      16 
;      17 
;      18 //========================================================================================================
;      19 #include <macros.h>
;      20 #include <sym.h>

	.CSEG
;      21 #include <config.h>
;      22 #include <driver.h>
;      23 #include <driver.c>
;      24 /*   .     */
;      25 byte ReadCode( void ){
_ReadCode:
;      26     byte ret;
;      27     //   
;      28     LCD_DATA_PORT=0x00;
	ST   -Y,R17
;	ret -> R17
	LDI  R30,LOW(0)
	OUT  0x1B,R30
;      29     LCD_DATA_DDR=0x00;
	OUT  0x1A,R30
;      30     //      
;      31     ClrBit(LCD_CONTROL_PORT, A0);
	CBI  0x15,4
;      32     SetBit(LCD_CONTROL_PORT, RDWR);
	CALL SUBOPT_0x0
;      33     //      
;      34     delay_us(10);
;      35     SetBit(LCD_CONTROL_PORT, E);
;      36     //      
;      37     delay_us(10);
;      38     ret=LCD_DATA_PIN;
;      39     //     
;      40     ClrBit(LCD_CONTROL_PORT,E);
;      41     return ret;
	RJMP _0x115
;      42 }
;      43 
;      44 
;      45 /*    */
;      46 void WaitBusy(void){
_WaitBusy:
;      47     byte stat;
;      48     //      BUSY
;      49     stat=ReadCode();
	ST   -Y,R17
;	stat -> R17
	CALL _ReadCode
	MOV  R17,R30
;      50     while(stat==(1<<BUSY)) stat=ReadCode();
_0x3:
	CPI  R17,128
	BRNE _0x5
	CALL _ReadCode
	MOV  R17,R30
;      51 }
	RJMP _0x3
_0x5:
	RJMP _0x115
;      52 
;      53 
;      54 //    RESET
;      55 void WaitReset(void){
;      56     byte stat;
;      57     stat=ReadCode();
;	stat -> R17
;      58     while(stat==(1<<RESET)) stat=ReadCode();
;      59 }
;      60 
;      61 
;      62 //    ON/OFF
;      63 void WaitON(void){
;      64     byte stat;
;      65     stat=ReadCode();
;	stat -> R17
;      66     while(stat==(1<<ONOFF)) stat=ReadCode();
;      67 }
;      68 
;      69 
;      70 /*     */
;      71 byte ReadData( void ){
_ReadData:
;      72     byte ret;
;      73     //   
;      74     WaitBusy();
	ST   -Y,R17
;	ret -> R17
	CALL _WaitBusy
;      75     // 
;      76     LCD_DATA_PORT=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
;      77     LCD_DATA_DDR=0x00;
	OUT  0x1A,R30
;      78     //  
;      79     SetBit(LCD_CONTROL_PORT, A0);
	SBI  0x15,4
;      80     SetBit(LCD_CONTROL_PORT, RDWR);
	CALL SUBOPT_0x0
;      81     //      
;      82     delay_us(10);
;      83     SetBit(LCD_CONTROL_PORT, E);
;      84     //     
;      85     delay_us(10);
;      86     ret=LCD_DATA_PIN;
;      87     //  
;      88     ClrBit(LCD_CONTROL_PORT,E);
;      89     // 
;      90     return ret;
	RJMP _0x115
;      91  }
;      92 
;      93 
;      94 /*    
;      95       */
;      96 void WriteData(byte data){
_WriteData:
;      97     WaitBusy();
;	data -> Y+0
	CALL _WaitBusy
;      98     LCD_DATA_DDR=0xFF;
	LDI  R30,LOW(255)
	OUT  0x1A,R30
;      99 
;     100     SetBit(LCD_CONTROL_PORT, A0);
	SBI  0x15,4
;     101     ClrBit(LCD_CONTROL_PORT, RDWR);
	CALL SUBOPT_0x1
;     102 
;     103     delay_us(10);
;     104     SetBit(LCD_CONTROL_PORT, E);
;     105     LCD_DATA_PORT=data;
;     106 
;     107     delay_us(10);
;     108     ClrBit(LCD_CONTROL_PORT, E);
;     109 }
	RJMP _0x116
;     110 
;     111 
;     112 /*    */
;     113 void WriteCode(byte code){
_WriteCode:
;     114     WaitBusy();
;	code -> Y+0
	CALL _WaitBusy
;     115     LCD_DATA_DDR=0xFF;
	LDI  R30,LOW(255)
	OUT  0x1A,R30
;     116 
;     117     ClrBit(LCD_CONTROL_PORT, A0);
	CBI  0x15,4
;     118     ClrBit(LCD_CONTROL_PORT, RDWR);
	CALL SUBOPT_0x1
;     119 
;     120     delay_us(10);
;     121     SetBit(LCD_CONTROL_PORT, E);
;     122     LCD_DATA_PORT=code;
;     123 
;     124     delay_us(10);
;     125     ClrBit(LCD_CONTROL_PORT, E);
;     126 }
_0x116:
	ADIW R28,1
	RET
;     127 
;     128 
;     129 /*  */
;     130 void LCD_INIT( void ){
_LCD_INIT:
;     131     byte stat;
;     132     //  Jtag
;     133     MCUCSR = 0x80;
	ST   -Y,R17
;	stat -> R17
	LDI  R30,LOW(128)
	OUT  0x34,R30
;     134     MCUCSR = 0x80;
	OUT  0x34,R30
;     135     // 
;     136     LCD_DATA_DDR=0xFF;
	LDI  R30,LOW(255)
	OUT  0x1A,R30
;     137     LCD_CONTROL_DDR=0xFF;
	OUT  0x14,R30
;     138     //     0.     RES
;     139     LCD_CONTROL_PORT=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
;     140     //    
;     141     delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     142     //  .( RES )
;     143     SetBit(LCD_CONTROL_PORT, RES);
	SBI  0x15,3
;     144 
;     145 
;     146     //   
;     147 
;     148     VR_VF_on;
	LDI  R30,LOW(47)
	ST   -Y,R30
	CALL _WriteCode
;     149     V5_regulator;
	LDI  R30,LOW(39)
	ST   -Y,R30
	CALL _WriteCode
;     150     electronic_volume_mode_set;
	LDI  R30,LOW(129)
	ST   -Y,R30
	CALL _WriteCode
;     151     electronic_volume_register_set;
	LDI  R30,LOW(7)
	ST   -Y,R30
	CALL _WriteCode
;     152     static_indicator_off;
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _WriteCode
;     153     static_indicator_off;
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _WriteCode
;     154     booster_ratio_select_mode_set;
	LDI  R30,LOW(248)
	ST   -Y,R30
	CALL _WriteCode
;     155     step_up;
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _WriteCode
;     156     duty_bias;
	LDI  R30,LOW(162)
	ST   -Y,R30
	CALL _WriteCode
;     157     common_output_mode;
	LDI  R30,LOW(200)
	ST   -Y,R30
	CALL _WriteCode
;     158     all_points_not_ON;
	LDI  R30,LOW(164)
	ST   -Y,R30
	CALL _WriteCode
;     159     display_not_reverse;
	LDI  R30,LOW(166)
	ST   -Y,R30
	CALL _WriteCode
;     160     ADC_select;
	LDI  R30,LOW(160)
	ST   -Y,R30
	CALL _WriteCode
;     161 
;     162 
;     163     // 1 
;     164     SetBit(LCD_CONTROL_PORT, E1);
	SBI  0x15,2
;     165     // 
;     166     LCD_ON;
	CALL SUBOPT_0x2
;     167     //  
;     168     LCD_START_LINE(0);
;     169 
;     170      //   2- 
;     171     ClrBit(LCD_CONTROL_PORT, E1);
	CBI  0x15,2
;     172     WaitBusy();
	CALL _WaitBusy
;     173     LCD_ON;
	CALL SUBOPT_0x2
;     174     //  
;     175     LCD_START_LINE(0);
;     176 }
_0x115:
	LD   R17,Y+
	RET
;     177 
;     178 //  
;     179 void LCD_CLS(void){
_LCD_CLS:
;     180     byte i;
;     181     byte j;
;     182     byte stat;
;     183 
;     184     ClrBit(LCD_CONTROL_PORT, E1);
	CALL __SAVELOCR4
;	i -> R17
;	j -> R16
;	stat -> R19
	CBI  0x15,2
;     185     delay_us(10);
	CALL SUBOPT_0x3
;     186 
;     187     LCD_OFF;
;     188     LCD_SET_ADDRESS(0);
;     189     for(i=0;i<8; i++){
_0xD:
	CPI  R17,8
	BRSH _0xE
;     190         LCD_SET_PAGE(i);
	CALL SUBOPT_0x4
;     191         for(j=0; j<64; j++){
_0x10:
	CPI  R16,64
	BRSH _0x11
;     192             WriteData(0x00);
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _WriteData
;     193         }
	SUBI R16,-1
	RJMP _0x10
_0x11:
;     194     }
	SUBI R17,-1
	RJMP _0xD
_0xE:
;     195 
;     196     LCD_ON;
	LDI  R30,LOW(175)
	ST   -Y,R30
	CALL _WriteCode
;     197     SetBit(LCD_CONTROL_PORT, E1);
	SBI  0x15,2
;     198     delay_us(10);
	CALL SUBOPT_0x3
;     199     LCD_OFF;
;     200     LCD_SET_ADDRESS(0);
;     201     for(i=0;i<8; i++){
_0x13:
	CPI  R17,8
	BRSH _0x14
;     202         LCD_SET_PAGE(i);
	CALL SUBOPT_0x4
;     203         for(j=0; j<64; j++){
_0x16:
	CPI  R16,64
	BRSH _0x17
;     204             WriteData(0x00);
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _WriteData
;     205         }
	SUBI R16,-1
	RJMP _0x16
_0x17:
;     206     }
	SUBI R17,-1
	RJMP _0x13
_0x14:
;     207     LCD_ON;
	LDI  R30,LOW(175)
	ST   -Y,R30
	CALL _WriteCode
;     208 }
	CALL __LOADLOCR4
	ADIW R28,4
	RET
;     209 #include <gl.c>
;     210 /*     1 */
;     211 void LCD_PUT_PIXEL(byte x, byte y){
;     212     // 
;     213     byte bite;
;     214     byte page;
;     215     byte data, data2;
;     216     //     
;     217     if((x>MAX_X)|(y>MAX_Y)) return;
;	x -> Y+5
;	y -> Y+4
;	bite -> R17
;	page -> R16
;	data -> R19
;	data2 -> R18
;     218     // 
;     219     if(x>=64){
;     220         ClrBit(LCD_CONTROL_PORT, E1);
;     221         x=x-64;
;     222         }
;     223         else{
;     224         SetBit(LCD_CONTROL_PORT, E1);
;     225         }
;     226     //page- 
;     227     page=y/8;
;     228     //bite-     
;     229     bite=y%8;
;     230     //   
;     231     LCD_SET_PAGE(page);
;     232     LCD_SET_ADDRESS(x);
;     233     //   LCD(2  ..   )
;     234     data=ReadData();
;     235     data=ReadData();
;     236     //       .
;     237     //    ,    
;     238     switch(met){
;     239         case MET_OR : { data=data|(1<<bite); break;}
;     240         case MET_XOR : {data=data^(1<<bite); break;}
;     241     }
;     242     LCD_SET_ADDRESS(x);
;     243     WriteData(data);
;     244 }
;     245 /*     .
;     246      ..      */
;     247 void LCD_LINE(byte x1, byte y1, byte x2, byte y2){
;     248         int dx, dy, i1, i2, i, kx, ky;
;     249         int d;
;     250         int x, y;
;     251         int flag;
;     252 
;     253         dy = y2 - y1;
;	x1 -> Y+25
;	y1 -> Y+24
;	x2 -> Y+23
;	y2 -> Y+22
;	dx -> R16,R17
;	dy -> R18,R19
;	i1 -> R20,R21
;	i2 -> Y+20
;	i -> Y+18
;	kx -> Y+16
;	ky -> Y+14
;	d -> Y+12
;	x -> Y+10
;	y -> Y+8
;	flag -> Y+6
;     254         dx = x2 - x1;
;     255         if (dx == 0 && dy == 0){
;     256                 LCD_PUT_PIXEL(x,y);
;     257                 return;
;     258         }
;     259         kx = 1;
;     260         ky = 1;
;     261 
;     262         if( dx < 0 ){ dx = -dx; kx = -1; }
;     263         else if(dx == 0)        kx = 0;
;     264 
;     265         if(dy < 0) { dy = -dy; ky = -1; }
;     266 
;     267         if(dx < dy){ flag = 0; d = dx; dx = dy; dy = d; }
;     268         else         flag = 1;
;     269 
;     270         i1 = dy + dy; d = i1 - dx; i2 = d - dx;
;     271         x = x1; y = y1;
;     272 
;     273         for(i=0; i < dx; i++){
;     274                 LCD_PUT_PIXEL(x,y);
;     275 
;     276                 if(flag) x += kx;
;     277                 else     y += ky;
;     278 
;     279                 if( d < 0 )
;     280                          d += i1;
;     281                 else{
;     282                          d += i2;
;     283                          if(flag) y += ky;
;     284                          else     x += kx;
;     285                 }
;     286         }
;     287         LCD_PUT_PIXEL(x,y);
;     288 }
;     289 
;     290 /*     .
;     291     ,  
;     292   sin  cos*/
;     293 
;     294 void LCD_CIRCLE( byte xc, byte yc, byte r )
;     295 {
;     296   int d, x, y;
;     297   x=0;
;	xc -> Y+8
;	yc -> Y+7
;	r -> Y+6
;	d -> R16,R17
;	x -> R18,R19
;	y -> R20,R21
;     298   y=r;
;     299   d=3-2*r; //   !
;     300   LCD_PUT_PIXEL(x+xc,y+yc);
;     301   LCD_PUT_PIXEL(x+xc,-y+yc);
;     302   LCD_PUT_PIXEL(-x+xc,-y+yc);
;     303   LCD_PUT_PIXEL(-x+xc,y+yc);
;     304   LCD_PUT_PIXEL(y+xc,x+yc);
;     305   LCD_PUT_PIXEL(y+xc,-x+yc);
;     306   LCD_PUT_PIXEL(-y+xc,-x+yc);
;     307   LCD_PUT_PIXEL(-y+xc,x+yc);
;     308   while(x<y){
;     309         if(d<=0){
;     310         d=d+4*x+6;
;     311         }else{
;     312         d=d+4*(x-y)+10;
;     313         y--;
;     314         }
;     315   x++;
;     316   //LCD_PUT_PIXEL(x, y);
;     317   LCD_PUT_PIXEL(x+xc,y+yc);
;     318   LCD_PUT_PIXEL(x+xc,-y+yc);
;     319   LCD_PUT_PIXEL(-x+xc,-y+yc);
;     320   LCD_PUT_PIXEL(-x+xc,y+yc);
;     321   LCD_PUT_PIXEL(y+xc,x+yc);
;     322   LCD_PUT_PIXEL(y+xc,-x+yc);
;     323   LCD_PUT_PIXEL(-y+xc,-x+yc);
;     324   LCD_PUT_PIXEL(-y+xc,x+yc);
;     325   }
;     326 }
;     327 #include <text.c>
;     328 /*    */
;     329 void LCD_PUT_BYTE(byte x, byte y, byte data){
_LCD_PUT_BYTE:
;     330     //  
;     331     byte tmp_data;
;     332     byte page;
;     333     byte bite;
;     334     byte inv_data;
;     335     //     
;     336     if((x>MAX_X)|(y>MAX_Y)) return;
	CALL __SAVELOCR4
;	x -> Y+6
;	y -> Y+5
;	data -> Y+4
;	tmp_data -> R17
;	page -> R16
;	bite -> R19
;	inv_data -> R18
	LDD  R26,Y+6
	LDI  R30,LOW(127)
	CALL __GTB12U
	MOV  R0,R30
	LDD  R26,Y+5
	LDI  R30,LOW(63)
	CALL __GTB12U
	OR   R30,R0
	BREQ _0x37
	RJMP _0x114
;     337     //   63   
;     338     if(x>=64){
_0x37:
	LDD  R26,Y+6
	CPI  R26,LOW(0x40)
	BRLO _0x38
;     339         ClrBit(LCD_CONTROL_PORT, E1);
	CBI  0x15,2
;     340         x=x-64;
	LDD  R30,Y+6
	SUBI R30,LOW(64)
	STD  Y+6,R30
;     341         }
;     342         else{
	RJMP _0x39
_0x38:
;     343         SetBit(LCD_CONTROL_PORT, E1);
	SBI  0x15,2
;     344         }
_0x39:
;     345     //      
;     346     page=y/8;
	LDD  R30,Y+5
	LSR  R30
	LSR  R30
	LSR  R30
	MOV  R16,R30
;     347     bite=y%8;
	LDD  R30,Y+5
	ANDI R30,LOW(0x7)
	MOV  R19,R30
;     348     //   (     )
;     349     LCD_SET_PAGE(page);
	CALL SUBOPT_0x5
;     350     LCD_SET_ADDRESS(x);
;     351     // , 2 , ..     
;     352     tmp_data=ReadData();
	CALL SUBOPT_0x6
;     353     tmp_data=ReadData();
;     354     //  
;     355     LCD_SET_PAGE(page);
	CALL SUBOPT_0x5
;     356     LCD_SET_ADDRESS(x);
;     357     //        
;     358     switch(met){
	MOV  R30,R5
;     359         case MET_OR : {WriteData(tmp_data|(data<<bite)); break;}
	CPI  R30,0
	BRNE _0x3D
	MOV  R30,R19
	LDD  R26,Y+4
	CALL __LSLB12
	OR   R30,R17
	RJMP _0x117
;     360         case MET_XOR : {WriteData(tmp_data^(data<<bite)); break;}
_0x3D:
	CPI  R30,LOW(0x1)
	BRNE _0x3E
	MOV  R30,R19
	LDD  R26,Y+4
	RJMP _0x118
;     361         case MET_NOT_OR : {WriteData(tmp_data| ((data^0xFF)<<bite)); break;}
_0x3E:
	CPI  R30,LOW(0x2)
	BRNE _0x3F
	LDD  R26,Y+4
	LDI  R30,LOW(255)
	EOR  R26,R30
	MOV  R30,R19
	CALL __LSLB12
	OR   R30,R17
	RJMP _0x117
;     362         case MET_NOT_XOR : {WriteData(tmp_data^((data^0xFF)<<bite)); break;}
_0x3F:
	CPI  R30,LOW(0x3)
	BRNE _0x3C
	LDD  R26,Y+4
	LDI  R30,LOW(255)
	EOR  R26,R30
	MOV  R30,R19
_0x118:
	CALL __LSLB12
	EOR  R30,R17
_0x117:
	ST   -Y,R30
	CALL _WriteData
;     363         }
_0x3C:
;     364     //          
;     365     if(bite>0){
	CPI  R19,1
	BRLO _0x41
;     366         LCD_SET_PAGE(page+1);
	CALL SUBOPT_0x7
;     367         LCD_SET_ADDRESS(x);
;     368 
;     369         tmp_data=ReadData();
	CALL SUBOPT_0x6
;     370         tmp_data=ReadData();
;     371 
;     372         LCD_SET_PAGE(page+1);
	CALL SUBOPT_0x7
;     373         LCD_SET_ADDRESS(x);
;     374 
;     375         switch(met){
	MOV  R30,R5
;     376             case MET_OR : {WriteData(tmp_data|(data>>(8-bite))); break;}
	CPI  R30,0
	BRNE _0x45
	LDI  R30,LOW(8)
	SUB  R30,R19
	LDD  R26,Y+4
	CALL __LSRB12
	OR   R30,R17
	RJMP _0x119
;     377             case MET_XOR : {WriteData(tmp_data^(data>>(8-bite))); break;}
_0x45:
	CPI  R30,LOW(0x1)
	BRNE _0x46
	LDI  R30,LOW(8)
	SUB  R30,R19
	LDD  R26,Y+4
	RJMP _0x11A
;     378             case MET_NOT_OR : {WriteData(tmp_data|((data^0xFF)>>(8-bite))); break;}
_0x46:
	CPI  R30,LOW(0x2)
	BRNE _0x47
	LDD  R26,Y+4
	LDI  R30,LOW(255)
	EOR  R26,R30
	LDI  R30,LOW(8)
	SUB  R30,R19
	CALL __LSRB12
	OR   R30,R17
	RJMP _0x119
;     379             case MET_NOT_XOR : {WriteData(tmp_data^((data^0xFF)>>(8-bite))); break;}
_0x47:
	CPI  R30,LOW(0x3)
	BRNE _0x44
	LDD  R26,Y+4
	LDI  R30,LOW(255)
	EOR  R26,R30
	LDI  R30,LOW(8)
	SUB  R30,R19
_0x11A:
	CALL __LSRB12
	EOR  R30,R17
_0x119:
	ST   -Y,R30
	CALL _WriteData
;     380         }
_0x44:
;     381     }
;     382 }
_0x41:
_0x114:
	CALL __LOADLOCR4
	ADIW R28,7
	RET
;     383 /*  .     8*5 . */
;     384 void LCD_PUTC(byte x, byte y, byte ch){
_LCD_PUTC:
;     385     byte textL;
;     386     byte i;
;     387     //      ,  
;     388     //   
;     389     if(ch<0x90) textL=0x20;
	ST   -Y,R17
	ST   -Y,R16
;	x -> Y+4
;	y -> Y+3
;	ch -> Y+2
;	textL -> R17
;	i -> R16
	LDD  R26,Y+2
	CPI  R26,LOW(0x90)
	BRSH _0x49
	LDI  R17,LOW(32)
;     390     else textL=0x60;
	RJMP _0x4A
_0x49:
	LDI  R17,LOW(96)
;     391 
;     392     for(i=0; i<5; i++){
_0x4A:
	LDI  R16,LOW(0)
_0x4C:
	CPI  R16,5
	BRSH _0x4D
;     393         LCD_PUT_BYTE(x+i, y, sym[ch-textL][i]);
	CALL SUBOPT_0x8
	LDD  R30,Y+4
	SUB  R30,R17
	LDI  R26,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_sym*2)
	SBCI R31,HIGH(-_sym*2)
	MOVW R26,R30
	MOV  R30,R16
	CALL SUBOPT_0x9
	ST   -Y,R30
	CALL _LCD_PUT_BYTE
;     394         }
	SUBI R16,-1
	RJMP _0x4C
_0x4D:
;     395     //  
;     396     LCD_PUT_BYTE(x+i, y, 0x00);
	CALL SUBOPT_0x8
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _LCD_PUT_BYTE
;     397 }
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0x113
;     398 /*     */
;     399 void LCD_PUTSF(byte x, byte y, flash unsigned char str[]){
_LCD_PUTSF:
;     400     byte i=0;
;     401     //     
;     402     while(str[i]){
	ST   -Y,R17
;	x -> Y+4
;	y -> Y+3
;	*str -> Y+1
;	i -> R17
	LDI  R17,0
_0x4E:
	MOV  R30,R17
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	CALL SUBOPT_0x9
	CPI  R30,0
	BREQ _0x50
;     403         LCD_PUTC(x+i*5+i, y, str[i]);
	MOV  R26,R17
	LDI  R30,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	LDD  R26,Y+4
	ADD  R30,R26
	ADD  R30,R17
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	MOV  R30,R17
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	CALL SUBOPT_0x9
	ST   -Y,R30
	CALL _LCD_PUTC
;     404         i++;
	SUBI R17,-1
;     405     }
	RJMP _0x4E
_0x50:
;     406 }
	LDD  R17,Y+0
_0x113:
	ADIW R28,5
	RET
;     407 //========================================================================================================
;     408 //   
;     409 
;     410 void main(void)
;     411 {
_main:
;     412 
;     413 byte i;
;     414 
;     415 
;     416 
;     417 //*********************************
;     418         LCD_INIT();
;	i -> R17
	CALL _LCD_INIT
;     419 
;     420 
;     421 while (1){ //    .
_0x51:
;     422 
;     423         met=MET_OR;
	CLR  R5
;     424         LCD_CLS();
	CALL _LCD_CLS
;     425 
;     426         met=MET_NOT_XOR;
	LDI  R30,LOW(3)
	MOV  R5,R30
;     427         LCD_PUTSF(56,28,"kazus");
	LDI  R30,LOW(56)
	ST   -Y,R30
	LDI  R30,LOW(28)
	CALL SUBOPT_0xA
;     428 
;     429         met=MET_XOR;
	LDI  R30,LOW(1)
	MOV  R5,R30
;     430         LCD_PUTSF(50,50,"kazus");
	LDI  R30,LOW(50)
	ST   -Y,R30
	CALL SUBOPT_0xA
;     431 
;     432         delay_ms(1000);
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     433 
;     434         };
	RJMP _0x51
;     435 }
_0x54:
	RJMP _0x54

	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET

	.DSEG
_p_S53:
	.BYTE 0x2

	.CSEG

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x0:
	SBI  0x15,5
	__DELAY_USB 40
	SBI  0x15,6
	__DELAY_USB 40
	IN   R17,25
	CBI  0x15,6
	MOV  R30,R17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x1:
	CBI  0x15,5
	__DELAY_USB 40
	SBI  0x15,6
	LD   R30,Y
	OUT  0x1B,R30
	__DELAY_USB 40
	CBI  0x15,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(175)
	ST   -Y,R30
	CALL _WriteCode
	LDI  R30,LOW(64)
	ST   -Y,R30
	JMP  _WriteCode

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x3:
	__DELAY_USB 40
	LDI  R30,LOW(62)
	ST   -Y,R30
	CALL _WriteCode
	LDI  R30,LOW(64)
	ST   -Y,R30
	CALL _WriteCode
	LDI  R17,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	MOV  R30,R17
	ORI  R30,LOW(0xB8)
	ST   -Y,R30
	CALL _WriteCode
	LDI  R16,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x5:
	MOV  R30,R16
	ORI  R30,LOW(0xB8)
	ST   -Y,R30
	CALL _WriteCode
	LDD  R30,Y+6
	ORI  R30,0x40
	ST   -Y,R30
	JMP  _WriteCode

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6:
	CALL _ReadData
	MOV  R17,R30
	CALL _ReadData
	MOV  R17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x7:
	MOV  R30,R16
	SUBI R30,-LOW(1)
	ORI  R30,LOW(0xB8)
	ST   -Y,R30
	CALL _WriteCode
	LDD  R30,Y+6
	ORI  R30,0x40
	ST   -Y,R30
	JMP  _WriteCode

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8:
	MOV  R30,R16
	LDD  R26,Y+4
	ADD  R30,R26
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x9:
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xA:
	ST   -Y,R30
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	JMP  _LCD_PUTSF

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xBB8
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__LSLB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSLB12R
__LSLB12L:
	LSL  R30
	DEC  R0
	BRNE __LSLB12L
__LSLB12R:
	RET

__LSRB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSRB12R
__LSRB12L:
	LSR  R30
	DEC  R0
	BRNE __LSRB12L
__LSRB12R:
	RET

__GTB12U:
	CP   R30,R26
	LDI  R30,1
	BRLO __GTB12U1
	CLR  R30
__GTB12U1:
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
