// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega32



sfrb TWBR=0;
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADCSR=6;     // for compatibility with older code
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;


// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm



// CodeVisionAVR C Compiler
// (C) 1998-2006 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;
typedef char *va_list;
typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+
#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-



//========================================================================================================
/*   */


flash const char sym[160][5] = 
flash const char sym[160][5] = 
flash const char sym[160][5] = 
{
 {0x00,0x00,0x00,0x00,0x00},                    //
 {0x00,0x00,0x4f,0x00,0x00},                    //!
 {0x00,0x07,0x00,0x07,0x00},                    //"
 {0x14,0x7f,0x14,0x7f,0x14},                    //#
 {0x24,0x2a,0x7f,0x2a,0x12},                    //$
 {0x23,0x13,0x08,0x64,0x62},                    //%
 {0x36,0x49,0x55,0x22,0x40},                    //&
 {0x00,0x05,0x03,0x00,0x00},                    //,
 {0x00,0x1c,0x22,0x41,0x00},                    //(
 {0x00,0x41,0x22,0x1c,0x00},                    //)
 {0x14,0x08,0x3E,0x08,0x14},                    //*
 {0x08,0x08,0x3E,0x08,0x08},                    //+
 {0x00,0x50,0x30,0x00,0x00},                    //,
 {0x08,0x08,0x08,0x08,0x08},                    //-
 {0x00,0x60,0x60,0x00,0x00},                    //.
 {0x20,0x10,0x08,0x04,0x02},                    ///
 {0x3e,0x51,0x49,0x45,0x3e},                    //0
 {0x00,0x42,0x7f,0x40,0x00},                    //1
 {0x42,0x61,0x51,0x49,0x46},                    //2
 {0x21,0x41,0x45,0x4b,0x31},                    //3
 {0x18,0x14,0x12,0x7f,0x10},                    //4
 {0x27,0x45,0x45,0x45,0x39},                    //5
 {0x3c,0x4a,0x49,0x49,0x30},                    //6
 {0x01,0x71,0x09,0x05,0x03},                    //7
 {0x36,0x49,0x49,0x49,0x36},                    //8
 {0x06,0x49,0x49,0x29,0x1e},                    //9
 {0x00,0x36,0x36,0x00,0x00},                    //:
 {0x00,0x56,0x36,0x00,0x00},                    //;
 {0x08,0x14,0x22,0x41,0x00},                    //<
 {0x14,0x14,0x14,0x14,0x14},                    //=
 {0x00,0x41,0x22,0x14,0x08},                    //>
 {0x02,0x01,0x51,0x09,0x06},                    //?
 {0x32,0x49,0x71,0x41,0x3e},                    //@
 {0x7e,0x11,0x11,0x11,0x7e},                    //A
 {0x7f,0x49,0x49,0x49,0x36},                    //B
 {0x3e,0x41,0x41,0x41,0x22},                    //C
 {0x7f,0x41,0x41,0x22,0x1c},                    //D
 {0x7f,0x49,0x49,0x49,0x41},                    //E
 {0x7f,0x09,0x09,0x09,0x01},                    //F
 {0x3e,0x41,0x49,0x49,0x3a},                    //G
 {0x7f,0x08,0x08,0x08,0x7f},                    //H
 {0x00,0x41,0x7f,0x41,0x00},                    //I
 {0x20,0x40,0x41,0x3f,0x01},                    //J
 {0x7f,0x08,0x14,0x22,0x41},                    //K
 {0x7f,0x40,0x40,0x40,0x40},                    //L
 {0x7f,0x02,0x0c,0x02,0x7f},                    //M
 {0x7f,0x04,0x08,0x10,0x7f},                    //N
 {0x3e,0x41,0x41,0x41,0x3e},                    //O
 {0x7f,0x09,0x09,0x09,0x06},                    //P
 {0x3e,0x41,0x51,0x21,0x5e},                    //Q
 {0x7f,0x09,0x19,0x29,0x46},                    //R
 {0x46,0x49,0x49,0x49,0x31},                    //S
 {0x01,0x01,0x7f,0x01,0x01},                    //T
 {0x3f,0x40,0x40,0x40,0x3f},                    //U
 {0x1f,0x20,0x40,0x20,0x1f},                    //V
 {0x3f,0x40,0x70,0x40,0x3f},                    //W
 {0x63,0x14,0x08,0x14,0x63},                    //X
 {0x07,0x08,0x70,0x08,0x07},                    //Y
 {0x61,0x51,0x49,0x45,0x43},                    //Z
 {0x00,0x7F,0x41,0x41,0x00},                    //[
 {0x02,0x04,0x08,0x10,0x20},                    //\ 
 {0x00,0x41,0x41,0x7F,0x00},                    //]
 {0x04,0x02,0x01,0x02,0x04},                    //^
 {0x40,0x40,0x40,0x40,0x40},                    //_      
 {0x00,0x01,0x02,0x04,0x00},                    //'
 {0x20,0x54,0x54,0x54,0x78},                    //a
 {0x7F,0x48,0x44,0x44,0x38},                    //b
 {0x38,0x44,0x44,0x44,0x20},                    //c
 {0x38,0x44,0x44,0x48,0x7F},                    //d
 {0x38,0x54,0x54,0x54,0x18},                    //e
 {0x08,0x7E,0x09,0x01,0x02},                    //f
 {0x0C,0x52,0x52,0x52,0x3E},                    //g
 {0x7F,0x08,0x04,0x04,0x78},                    //h
 {0x00,0x44,0x7D,0x40,0x00},                    //i
 {0x20,0x40,0x44,0x3D,0x00},                    //j
 {0x7F,0x10,0x28,0x44,0x00},                    //k
 {0x00,0x41,0x7F,0x40,0x00},                    //l
 {0x7C,0x04,0x18,0x04,0x78},                    //m
 {0x7C,0x08,0x04,0x04,0x78},                    //n
 {0x38,0x44,0x44,0x44,0x38},                    //o
 {0x7C,0x14,0x14,0x14,0x08},                    //p
 {0x08,0x14,0x14,0x18,0x7C},                    //q
 {0x7C,0x08,0x04,0x04,0x08},                    //r
 {0x48,0x54,0x54,0x54,0x20},                    //s
 {0x04,0x3F,0x44,0x40,0x20},                    //t
 {0x3C,0x40,0x40,0x20,0x7C},                    //u
 {0x1C,0x20,0x40,0x20,0x1C},                    //v
 {0x3C,0x40,0x30,0x40,0x3C},                    //w
 {0x44,0x28,0x10,0x28,0x44},                    //x
 {0x0C,0x50,0x50,0x50,0x3C},                    //y
 {0x44,0x64,0x54,0x4C,0x44},                    //z
 {0x00,0x08,0x36,0x41,0x00},                    //{
 {0x00,0x00,0x7f,0x00,0x00},                    //|
 {0x00,0x41,0x36,0x08,0x00},                    //}
 {0x02,0x01,0x02,0x02,0x01},                    //~
 {0x00,0x00,0x00,0x00,0x00},                    //
 {0x7e,0x11,0x11,0x11,0x7e},                    //A
 {0x7f,0x49,0x49,0x49,0x33},                    //
 {0x7f,0x49,0x49,0x49,0x36},                    //
 {0x7f,0x01,0x01,0x01,0x03},                    //
 {0xe0,0x51,0x4f,0x41,0xff},                    //
 {0x7f,0x49,0x49,0x49,0x41},                    //E
 {0x77,0x08,0x7f,0x08,0x77},                    //
 {0x41,0x49,0x49,0x49,0x36},                    //
 {0x7f,0x10,0x08,0x04,0x7f},                    //
 {0x7c,0x21,0x12,0x09,0x7c},                    //
 {0x7f,0x08,0x14,0x22,0x41},                    //K
 {0x20,0x41,0x3f,0x01,0x7f},                    //
 {0x7f,0x02,0x0c,0x02,0x7f},                    //M
 {0x7f,0x08,0x08,0x08,0x7f},                    //H
 {0x3e,0x41,0x41,0x41,0x3e},                    //O
 {0x7f,0x01,0x01,0x01,0x7f},                    //
 {0x7f,0x09,0x09,0x09,0x06},                    //P
 {0x3e,0x41,0x41,0x41,0x22},                    //C
 {0x01,0x01,0x7f,0x01,0x01},                    //T
 {0x47,0x28,0x10,0x08,0x07},                    //
 {0x1c,0x22,0x7f,0x22,0x1c},                    //
 {0x63,0x14,0x08,0x14,0x63},                    //X
 {0x7f,0x40,0x40,0x40,0xff},                    //
 {0x07,0x08,0x08,0x08,0x7f},                    //
 {0x7f,0x40,0x7f,0x40,0x7f},                    //
 {0x7f,0x40,0x7f,0x40,0xff},                    //
 {0x01,0x7f,0x48,0x48,0x30},                    //
 {0x7f,0x48,0x30,0x00,0x7f},                    //
 {0x00,0x7f,0x48,0x48,0x30},                    //
 {0x22,0x41,0x49,0x49,0x3e},                    //
 {0x7f,0x08,0x3e,0x41,0x3e},                    //
 {0x46,0x29,0x19,0x09,0x7f},                    // 
 {0x20,0x54,0x54,0x54,0x78},                    //a
 {0x3c,0x4a,0x4a,0x49,0x31},                    //
 {0x7c,0x54,0x54,0x28,0x00},                    //
 {0x7c,0x04,0x04,0x04,0x0c},                    //
 {0xe0,0x54,0x4c,0x44,0xfc},                    //
 {0x38,0x54,0x54,0x54,0x18},                    //e
 {0x6c,0x10,0x7c,0x10,0x6c},                    //
 {0x44,0x44,0x54,0x54,0x28},                    //
 {0x7c,0x20,0x10,0x08,0x7c},                    //
 {0x7c,0x41,0x22,0x11,0x7c},                    //
 {0x7c,0x10,0x28,0x44,0x00},                    //
 {0x20,0x44,0x3c,0x04,0x7c},                    //
 {0x7c,0x08,0x10,0x08,0x7c},                    //
 {0x7c,0x10,0x10,0x10,0x7c},                    //
 {0x38,0x44,0x44,0x44,0x38},                    //o
 {0x7c,0x04,0x04,0x04,0x7c},                    //
 {0x7C,0x14,0x14,0x14,0x08},                    //p 
 {0x38,0x44,0x44,0x44,0x20},                    //c
 {0x04,0x04,0x7c,0x04,0x04},                    //
 {0x0C,0x50,0x50,0x50,0x3C},                    //
 {0x30,0x48,0xfc,0x48,0x30},                    //
 {0x44,0x28,0x10,0x28,0x44},                    //x
 {0x7c,0x40,0x40,0x40,0xfc},                    //
 {0x0c,0x10,0x10,0x10,0x7c},                    //
 {0x7c,0x40,0x7c,0x40,0x7c},                    //
 {0x7c,0x40,0x7c,0x40,0xfc},                    //
 {0x04,0x7c,0x50,0x50,0x20},                    //
 {0x7c,0x50,0x50,0x20,0x7c},                    //
 {0x7c,0x50,0x50,0x20,0x00},                    //
 {0x28,0x44,0x54,0x54,0x38},                    //
 {0x7c,0x10,0x38,0x44,0x38},                    //
 {0x08,0x54,0x34,0x14,0x7c}                   //
};
// 
//     

                 //   AVR123.NM.RU  
                 // LCD           ATmega32

//   

//              //   AVR123.NM.RU


//  
//  
unsigned char met;
unsigned char met;
unsigned char met;
// .   
//                            






/*   .     */
unsigned char ReadCode( void ){
unsigned char ReadCode( void ){
    unsigned char ret;
    //   
    PORTA =0x00;
    DDRA=0x00; 
    //      
    (PORTC&=~(1<<4     ));
    (PORTC|=(1<<5   )); 
    //                   
    delay_us(10); 
    (PORTC|=(1<<6      )); 
    //                   
    delay_us(10);
    ret=PINA;         
    //     
    (PORTC&=~(1<<6      ));
    return ret;
}  


/*    */
void WaitBusy(void){
    unsigned char stat;
    //      BUSY
    stat=ReadCode();
    while(stat==(1<<7)) stat=ReadCode();
}


//    RESET
void WaitReset(void){
    unsigned char stat;
    stat=ReadCode();
    while(stat==(1<<4)) stat=ReadCode();
} 


//    ON/OFF
void WaitON(void){
    unsigned char stat;
    stat=ReadCode();
    while(stat==(1<<5)) stat=ReadCode();
}


/*     */
unsigned char ReadData( void ){
    unsigned char ret;
    //   
    WaitBusy();
    // 
    PORTA =0x00;
    DDRA=0x00; 
    //  
    (PORTC|=(1<<4     ));
    (PORTC|=(1<<5   )); 
    //                           
    delay_us(10);
    (PORTC|=(1<<6      )); 
    //                     
    delay_us(10);
    ret=PINA;         
    //  
    (PORTC&=~(1<<6      ));
    // 
    return ret;
 }


/*    
      */
void WriteData(unsigned char data){ 
    WaitBusy();   
    DDRA=0xFF;
    
    (PORTC|=(1<<4     ));
    (PORTC&=~(1<<5   ));
    
    delay_us(10);
    (PORTC|=(1<<6      ));
    PORTA =data;
                               
    delay_us(10);
    (PORTC&=~(1<<6      ));
}


/*    */
void WriteCode(unsigned char code){         
    WaitBusy();
    DDRA=0xFF;    
    
    (PORTC&=~(1<<4     ));
    (PORTC&=~(1<<5   ));
     
    delay_us(10);
    (PORTC|=(1<<6      ));
    PORTA =code;
    
    delay_us(10);
    (PORTC&=~(1<<6      ));
}


/*  */                              
void LCD_INIT( void ){ 
    unsigned char stat;
    //  Jtag
    MCUCSR = 0x80;
    MCUCSR = 0x80;
    // 
    DDRA=0xFF;           
    DDRC=0xFF;
    //     0.     RES
    PORTC=0x00;
    //    
    delay_ms(100); 
    //  .( RES )      
    (PORTC|=(1<<3    ));    

               
    //   

    WriteCode(0x2F);              	;              	
    WriteCode(0x27);              	;              	
    WriteCode(0x81);              	;              	
    WriteCode(0x07);  		;  		
    WriteCode(0x00);	       	;	       	
    WriteCode(0x00);	       	;	       	
    WriteCode(0xF8);	       	;	       	
    WriteCode(0x03);	       	;	       	
    WriteCode(0xA2);	       	        ;	       	        
    WriteCode(0xC8);	       	;	       	
    WriteCode(0xA4);	       	;	       	
    WriteCode(0xA6);	       	;	       	
    WriteCode(0xA0);	       	;	       	


    // 1    
    (PORTC|=(1<<2     )); 
    //  
    WriteCode(0xAF);
    //  
    WriteCode(0x40 | 0);

     //   2- 
    (PORTC&=~(1<<2     ));
    WaitBusy();
    WriteCode(0xAF);
    //  
    WriteCode(0x40 | 0);
}                                   

//  
void LCD_CLS(void){
    unsigned char i;
    unsigned char j;  
    unsigned char stat;

    (PORTC&=~(1<<2     )); 
    delay_us(10);

    WriteCode(0x3E) ;
    WriteCode(0x40 | 0) ;
    for(i=0;i<8; i++){
        WriteCode(0xB8 | i)  ;
        for(j=0; j<64; j++){
            WriteData(0x00);
        }
    }                  
    
    WriteCode(0xAF);
    (PORTC|=(1<<2     ));
    delay_us(10);
    WriteCode(0x3E) ;
    WriteCode(0x40 | 0) ;
    for(i=0;i<8; i++){
        WriteCode(0xB8 | i)  ; 
        for(j=0; j<64; j++){
            WriteData(0x00);
        }
    } 
    WriteCode(0xAF);
}  
/*     1 */
void LCD_PUT_PIXEL(unsigned char x, unsigned char y){
void LCD_PUT_PIXEL(unsigned char x, unsigned char y){
    // 
    unsigned char bite;
    unsigned char page; 
    unsigned char data, data2;
    //      
    if((x>127)|(y>63  )) return;
    // 
    if(x>=64){
        (PORTC&=~(1<<2     ));
        x=x-64;
        }
        else{
        (PORTC|=(1<<2     ));
        }   
    //page-  
    page=y/8;
    //bite-     
    bite=y%8;
    //   
    WriteCode(0xB8 | page)  ;
    WriteCode(0x40 | x) ;
    //   LCD(2  ..   )
    data=ReadData(); 
    data=ReadData();
    //       .
    //    ,      
    switch(met){
        case 0 : { data=data|(1<<bite); break;}
        case 1  : {data=data^(1<<bite); break;}  
    }
    WriteCode(0x40 | x) ;
    WriteData(data);
}
/*     .
     ..      */
void LCD_LINE(unsigned char x1, unsigned char y1, unsigned char x2, unsigned char y2){
        int dx, dy, i1, i2, i, kx, ky;
        int d;     
        int x, y;
        int flag;

        dy = y2 - y1;
        dx = x2 - x1;
        if (dx == 0 && dy == 0){
                LCD_PUT_PIXEL(x,y);    
                return;
        }
        kx = 1; 
        ky = 1; 

        if( dx < 0 ){ dx = -dx; kx = -1; }
        else if(dx == 0)        kx = 0;    

        if(dy < 0) { dy = -dy; ky = -1; }

        if(dx < dy){ flag = 0; d = dx; dx = dy; dy = d; }
        else         flag = 1;

        i1 = dy + dy; d = i1 - dx; i2 = d - dx;
        x = x1; y = y1;

        for(i=0; i < dx; i++){
                LCD_PUT_PIXEL(x,y);     

                if(flag) x += kx;
                else     y += ky;

                if( d < 0 ) 
                         d += i1;
                else{       
                         d += i2;
                         if(flag) y += ky; 
                         else     x += kx;
                }
        }
        LCD_PUT_PIXEL(x,y);
}
    
/*     . 
    ,   
  sin  cos*/

void LCD_CIRCLE( unsigned char xc, unsigned char yc, unsigned char r )
{
  int d, x, y;
  x=0;
  y=r;
  d=3-2*r; //   !
  LCD_PUT_PIXEL(x+xc,y+yc);
  LCD_PUT_PIXEL(x+xc,-y+yc);
  LCD_PUT_PIXEL(-x+xc,-y+yc);
  LCD_PUT_PIXEL(-x+xc,y+yc);
  LCD_PUT_PIXEL(y+xc,x+yc);
  LCD_PUT_PIXEL(y+xc,-x+yc);
  LCD_PUT_PIXEL(-y+xc,-x+yc);
  LCD_PUT_PIXEL(-y+xc,x+yc);
  while(x<y){
        if(d<=0){
        d=d+4*x+6;
        }else{
        d=d+4*(x-y)+10;
        y--;
        }   
  x++;
  //LCD_PUT_PIXEL(x, y);
  LCD_PUT_PIXEL(x+xc,y+yc);
  LCD_PUT_PIXEL(x+xc,-y+yc);
  LCD_PUT_PIXEL(-x+xc,-y+yc);
  LCD_PUT_PIXEL(-x+xc,y+yc);
  LCD_PUT_PIXEL(y+xc,x+yc);
  LCD_PUT_PIXEL(y+xc,-x+yc);
  LCD_PUT_PIXEL(-y+xc,-x+yc);
  LCD_PUT_PIXEL(-y+xc,x+yc);
  }  
}       
/*    */
void LCD_PUT_BYTE(unsigned char x, unsigned char y, unsigned char data){
void LCD_PUT_BYTE(unsigned char x, unsigned char y, unsigned char data){
    //  
    unsigned char tmp_data;
    unsigned char page;
    unsigned char bite;
    unsigned char inv_data;
    //     
    if((x>127)|(y>63  )) return;
    //   63   
    if(x>=64){
        (PORTC&=~(1<<2     ));
        x=x-64;
        }
        else{
        (PORTC|=(1<<2     ));
        }     
    //      
    page=y/8;
    bite=y%8;
    //   (     )
    WriteCode(0xB8 | page)  ;
    WriteCode(0x40 | x) ;
    // , 2 , ..     
    tmp_data=ReadData(); 
    tmp_data=ReadData();  
    //  
    WriteCode(0xB8 | page)  ;
    WriteCode(0x40 | x) ;
    //                             
    switch(met){
        case 0 : {WriteData(tmp_data|(data<<bite)); break;}
        case 1  : {WriteData(tmp_data^(data<<bite)); break;} 
        case 2 : {WriteData(tmp_data| ((data^0xFF)<<bite)); break;}
        case 3 : {WriteData(tmp_data^((data^0xFF)<<bite)); break;}  
        }
    //          
    if(bite>0){ 
        WriteCode(0xB8 | page+1)  ;
        WriteCode(0x40 | x) ;
       
        tmp_data=ReadData(); 
        tmp_data=ReadData();
        
        WriteCode(0xB8 | page+1)  ;
        WriteCode(0x40 | x) ;
    
        switch(met){
            case 0 : {WriteData(tmp_data|(data>>(8-bite))); break;}
            case 1  : {WriteData(tmp_data^(data>>(8-bite))); break;} 
            case 2 : {WriteData(tmp_data|((data^0xFF)>>(8-bite))); break;}
            case 3 : {WriteData(tmp_data^((data^0xFF)>>(8-bite))); break;} 
        }
    } 
}
/*  .     8*5 . */
void LCD_PUTC(unsigned char x, unsigned char y, unsigned char ch){
    unsigned char textL;
    unsigned char i;   
    //      ,   
    //   
    if(ch<0x90) textL=0x20;
    else textL=0x60;

    for(i=0; i<5; i++){
        LCD_PUT_BYTE(x+i, y, sym[ch-textL][i]);
        } 
    //  
    LCD_PUT_BYTE(x+i, y, 0x00);      
}   
/*     */            
void LCD_PUTSF(unsigned char x, unsigned char y, flash unsigned char str[]){
    unsigned char i=0;
    //     
    while(str[i]){
        LCD_PUTC(x+i*5+i, y, str[i]);
        i++; 
    }  
}
//========================================================================================================
//                              

void main(void)
{

unsigned char i;

             

//*********************************
        LCD_INIT();  
        

while (1){ //    .

        met=0;
        LCD_CLS(); 
                     
        met=3;
        LCD_PUTSF(56,28,"kazus");  
  
        met=1 ;
        LCD_PUTSF(50,50,"kazus"); 
          
        delay_ms(1000);
        
        };          
}
